#
#   COMPONENT_NAME: somx
#
#   ORIGINS: 27
#
#
#    25H7912  (C)  COPYRIGHT International Business Machines Corp. 1996
#   All Rights Reserved
#   Licensed Materials - Property of IBM
#   US Government Users Restricted Rights - Use, duplication or
#   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# @(#) 1.7 src/somples.nt/somd/c/dii/vac.mak, somples.somd, som3.0 12/17/96 10:42:41 [12/23/96 08:40:20]  

# DISCLAIMER OF WARRANTIES.
# The following [enclosed] code is sample code created by IBM
# Corporation. This sample code is not part of any standard or IBM
# product and is provided to you solely for the purpose of assisting
# you in the development of your applications.  The code is provided
# "AS IS". IBM MAKES NO WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT
# NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE, REGARDING THE FUNCTION OR PERFORMANCE OF
# THIS CODE.  IBM shall not be liable for any damages arising out of
# your use of the sample code, even if they have been advised of the
# possibility of such damages.
#
# DISTRIBUTION.
# This sample code can be freely distributed, copied, altered, and
# incorporated into other software, provided that it bears the above
# Copyright notice and DISCLAIMER intact.
!include ..\..\..\vacmake.hd

INCS = -I$(SOMBASE)\include
INCLS = foo.h
IDLFILES = foo.idl

DLLOBJS = foo.od initmod.od

DEFSPEC=/DEF:foo.nid

all: $(SOMCORBA_DEPEND) foo.dll diitest.exe som.ir somdimpl

### -- Build the DLL.
foo.nid: *.idl
foo.dll: foo.nid $(DLLOBJS) foo.lib
foo.lib: foo.nid $(DLLOBJS)
foo.od: foo.ih foo.h foo.c

diitest.exe: foo.lib diitest.obj
diitest.obj: $(INCLS) diitest.c

##Build the initialization module from the idl files.
initmod.od:  initmod.c

initmod.c: $(IDLS)
	sc -simod -mdll=foo.dll -mimod=$@ *.idl

### -- Put the IDL descriptions into the Interface Repository.
som.ir: som_ir
som_ir: foo.idl
	-$(SC) -sir -u -mnolock $(INCS) *.idl
	echo x > som_ir

clnimpl:
	-regimpl -D -i diiServer1
	-del somdimpl

### -- Build the DSOM Implementation Repository.
somdimpl:
	-regimpl -A -i diiServer1
	-regimpl -a -i diiServer1 -c Foo
	-regimpl -L -i diiServer1
	@echo x > somdimpl

clean: clnimpl
	del som.ir
	del som_ir
	del initmod.c

!include ..\..\..\vacmake.tl
