#
#   COMPONENT_NAME: somx
#
#   ORIGINS: 27
#
#
#    25H7912  (C)  COPYRIGHT International Business Machines Corp. 1996
#   All Rights Reserved
#   Licensed Materials - Property of IBM
#   US Government Users Restricted Rights - Use, duplication or
#   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#    @(#) 1.5 src/somples.nt/somd/cpp/event/vac.mak, somples.somd, som3.0 12/16/96 14:28:36 [12/23/96 08:40:36]




# DISCLAIMER OF WARRANTIES.
# The following [enclosed] code is sample code created by IBM
# Corporation. This sample code is not part of any standard or IBM
# product and is provided to you solely for the purpose of assisting
# you in the development of your applications.  The code is provided
# "AS IS". IBM MAKES NO WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT
# NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE, REGARDING THE FUNCTION OR PERFORMANCE OF
# THIS CODE.  IBM shall not be liable for any damages arising out of
# your use of the sample code, even if they have been advised of the
# possibility of such damages.
#
# DISTRIBUTION.
# This sample code can be freely distributed, copied, altered, and
# incorporated into other software, provided that it bears the above
# Copyright notice and DISCLAIMER intact.
!include ..\..\..\vacmake.hd

INCS = -I$(SOMBASE)\include
INCLS = eventcom.xh eventch.xh cell.xh
IDLFILES = eventcom.idl eventch.idl cell.idl

PRIVCPPFLAGSDLL= /Ms
DLLOBJS = eventcom.od eventch.od cell.od eventi.od

DEFSPEC=/DEF:event.nid

PRIVLDFLAGSDLL=$(ENTRYFLAG) $(SOMINITOBJ)


all: $(SOMXH_DEPEND) event.dll consumer.exe eventcli.exe eventsvr.exe som.ir somdimpl

### -- Build the DLL.
event.nid: eventcom.idl eventch.idl cell.idl
	sc -sdef -mdll=event.dll *.idl
event.lib: event.nid $(DLLOBJS)
event.dll: event.nid $(DLLOBJS) event.lib
event.lib: event.nid $(DLLOBJS)
cell.od:  cell.cpp cell.xh cell.xih

eventcom.od: eventcom.cpp eventcom.xh eventcom.xih

eventch.od: eventch.cpp eventch.xh eventch.xih eventcom.xih


eventcli.exe: event.lib eventcli.obj
eventcli.obj: $(INCLS) eventcli.cpp

consumer.exe: event.lib consumer.obj
consumer.obj: $(INCLS) consumer.cpp

eventsvr.exe: event.lib eventsvr.obj
eventsvr.obj: $(INCLS) eventsvr.cpp

##Build the initialization module from the idl files.
eventi.od:  eventi.c

eventi.c: $(IDLS)
	sc -simod -mdll=event.dll -mimod=$@ *.idl

### -- Put the IDL descriptions into the Interface Repository.
som.ir: som_ir
som_ir: eventch.idl eventcom.idl cell.idl
	-$(SC) -sir -u -mnolock $(INCS) *.idl
	echo x > som_ir



##Build DSOM implementation repository
somdimpl:
	-regimpl -A -i cellServer2 -p eventsvr
	-regimpl -a -i cellServer2 -c Cell \
		 -c EventChannelAdmin::ConsumerAdmin \
		 -c EventChannelAdmin::EventChannel \
		 -c EventChannelAdmin::SupplierAdmin \
		 -c EventComm::Consumer \
		 -c EventComm::Supplier \
		 -c EventComm::EventConnection
	-regimpl -L -i cellServer2
	echo "" >somdimpl


# Cleanup the DSOM Implementation Repository.
cleanimpl:
	-regimpl -D -i cellServer2
        -erase somdimpl

clean: cleanimpl
	del som.ir
	del som_ir
	del eventi.c

!include ..\..\..\vacmake.tl
